
            title       video
            locals

X           equ         (byte ptr 0)
Y           equ         (byte ptr 1)
CrtMode     equ         (byte ptr 49H)	        ; 騩 ०
CrtWidth    equ         (byte ptr 4AH)          ; ਭ ࠭

data        segment     word        public
            extrn       WindMin:word, WindMax:word
data        ends

code        segment byte    public
            assume  cs:code, ds:data
            public  Win2Video
            public  Scr2Video

Win2Video:
;
; internal (near) subroutine of TCRT unit
; functions : - converts window coordinates ( X, Y)
;             to videobuffer address
;             - corrects (if necessary) number of bytes ( Len)
;             to be sent to videobuffer
; on entry  : dl - X coordinate
;             dh - Y coordinate
;             cl - Len
; returns   : es:di - videobuffer address
;             cl - corrected Len if ( X, Y) values correct
;                              0 if ( X, Y) values incorrect
;             ch - 0
; destroes  : ax
;

; if X+WindMin.X-1>=CrtWidth then Error
            add     dl,WindMin.X
            dec     dl
            cmp     dl,80
            jae     Error

; if Y+WindMin.Y-1>=25 then Error
            add     dh,WindMin.Y
            dec     dh
            cmp     dh,25
            jae     Error

; if X+WindMin.X-1+Len>=CrtWidth then
;                       Len:= CrtWidth

            mov     ch,cl
            add     ch,dl
            jc      @@Check
            cmp     ch,80
            jbe     @@Skip
@@Check:
            mov     cl,80
            sub     cl,dl
            dec     cl
@@Skip:
            xor     ch,ch

; entry point
; ८ࠧ ࠭ न [0..24, 0..79]

Scr2Video:
            mov     ax,40h              ; BIOS area segment
            mov     es,ax
            mov     al,dh               ; ᫮ ப  
            mul     es:CrtWidth         ; 㬭  ᫮ 
            xor     dh,dh               ; ਡ ᫮ 
            add     ax,dx               ; ᫥  
            shl     ax,1                ; 1 ᫮  = 1 ᨬ
            mov     di,ax               ; ࠭ ᫥ ᬥ饭
            mov     ax,0b800h           ; 梥⭮ ᥣ
            cmp     es:CrtMode,7        ; ⠭ ୮- ० ?
            jne     @@Skip
            mov     ah,0b0h             ; ax -> / ᥣ
@@Skip:
            mov     es,ax
            retn

Error:      mov     ax,0b800h
            mov     es,ax
            xor     di,di
            xor     cx,cx
            retn

code        ends
            end
